<!DOCTYPE html>
<html lang="en">

<head>
	<meta charset="UTF-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<link rel="stylesheet" href="../CSS and JS\style.css">
	<link rel="stylesheet" href="../CSS and JS\prism.css">
	<link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

	<title>Loop</title>
</head>

<body>
	<h1>For and while loop</h1>
	<p>
		For mer info: <a href="https://en.cppreference.com/w/cpp/language/for">for</a>, <a
			href="https://en.cppreference.com/w/cpp/language/while">while</a> og <a
			href="https://en.cppreference.com/w/cpp/language/do">do while</a>.
	</p>
	<h2>Intro</h2>
	<p>
		Løkker (loops) brukes for å kjøre lik kode flere ganger.
		Du er kanskje allerede kjent med løkker allerede fra python,
		men i C++ implementeres de litt anderledes.
	</p>
	<p>
		Det er tre forskjellige løkker man kan bruke: <i>for</i>, <i>while</i> og <i>do while</i>.
		Disse løkkene kan brukes om hverandre, men ofte er en av dem mer intuitiv å bruke enn de andre.
	</p>

	<h2>For-løkkken</h2>
	<p>
		En for løkke i C++ skrives slik:
	</p>
	<pre>
<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
for (type type_name = value; condition; iterator)
{
	// code
}
</code>
    </pre>
	<p>
		Som du ser gjør for-løkken tre ting i tilleg til koden innenfor krøllparantesene.
	<ol>
		<li>Lager en variabel</li>
		<li>Skjekker om noe er sant (condition)</li>
		<li>Itererer</li>
	</ol>
	</p>
	<p>
		I eksempelet under ser du et eksempel på hva det kan bety i praksis.
	</p>
	<pre>
	<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
vector<string> my_vector = {"Hello", "from", "the", "other", "side"};
for (int i = 0; i < my_vector.size(); i++)
{
	cout << my_vector[i] << " ";
}
</code>
	</pre>
	<p>
		Dette printer ut i terminalen "Hello from the other side".
		For-løkken over tilsvarer <code>for i in range(0, len(my_list)):</code> i python.
		Det er også verdt å merke at ettersom koden inni for-løkken bare er på en linje,
		kunne krøllparantesene blitt fjernet i dette eksempelet.
	</p>
	<p>
		I python er det vanlig å iterere gjennom lister ved hjelp av nøkkelordet in (faktisk lager range funksjonen bare en
		liste som for-løkken itererer gjennom).
		I C++ kan man få til det samme med nøkkelordet <i>auto</i>:
	</p>
	<pre>
	<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
vector my_vector = {"Hello", "from", "the", "other", "side"};
for (auto element : my_vector) cout << element << " ";
</code>
	</pre>
	<p>
		Her vil koden, som i forrige eksempelet printe ut "Hello from the other side".
	</p>

	<h2>While-løkken</h2>
	<p>
		While-løkken fungerer på mange måter som i python.
		Den kjører koden så lenge det som er inni betingelsen er sant.
		I eksempelet under avslutten løkken når brukeren skriver <i>y</i> for å avslutte løkken.
	</p>
	<pre>
	<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
char response;
while (response != 'y')
{
	// Do stuff
	cout << "Do you want to quit? (y/n): ";
	cin >> response;
}
</code>
	</pre>

	<h2>Do while</h2>
	<p>
		<i>Do while</i>-løkken er godt egnet hvis du ønsker at koden innenfor krøllparantesene alltid kjøres hvertfall en
		gang,
		eller hvis betingelsen avhenger av kalkuleringen.
		I eksempelet under garanterer vi at hvertfall ett tilfeldig tall skrives ut (<i>0</i>) og betingelsen avhenger av
		den "<i>avanserte</i>" kalkuleringen <code>random_number = rand() % 10;</code>.
	</p>
	<pre>
	<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
int random_number;
do
{
	random_number = rand() % 10;
	cout << random_number << endl;
} while (random_number > 0);
</code>
	</pre>

	<script src="../CSS and JS\prism.js"></script>
	<script src="../CSS and JS/copy.js"></script>
</body>

</html>